import chimera, numpy, struct
from chimera import runCommand
from numpy import array

from StructBio.Scenographics.solids import Solids

# Use three colors from "earth tone" selection:
c1 = "daa520"   # goldenrod
c2 = "20b2aa"   # light sea green
c3 = "dda0dd"   # plum

def hex2RGBtuple(cStr):
    return tuple(array(struct.unpack('BBB', cStr.decode('hex')))/255.)

runCommand("set bg_color white")
phi = (1. + 5.**.5)/2.  # phi the golden ratio.
dodecaScene = Solids()
radius = 1.0

for r in (-1., 1.):
    for s in (-phi, phi):
        n1 = array((0., s, r)); n2 = array((r, 0., s)); n3 = array((s, r, 0.))
        dodecaScene.addDisk(n1, n1, 0.01, radius, hex2RGBtuple(c1))
        dodecaScene.addDisk(n2, n2, 0.01, radius, hex2RGBtuple(c2))
        dodecaScene.addDisk(n3, n3, 0.01, radius, hex2RGBtuple(c3))

dodecaScene.display()
